## yade 0.60.3

=== SConstruct ===
#!/usr/bin/scons
# coding: UTF-8
# vim:syntax=python:

#
# This is the master build file for scons (http://www.scons.org). It is experimental, though it build very well for me. Prequisities for running are having scons installed (debian & family: package scons)
#
# Type "scons -h" for yade-specific options and "scons -H" for scons' options. Note that yade options will be remembered (saved in scons.config) so that you need to specify them only for the first time. Like this, for example:
#
#	scons -j2 brief=1 debug=0 optimize=1 profile=1 exclude=extra,lattice,snow
#
# Next time, you can simply run "scons" or "scons -j4" (for 4-parallel builds) to rebuild targets that need it. IF YOU NEED TO READ CODE IN THIS FILE, SOMETHING IS BROKEN AND YOU SHOULD REALLY TELL ME.
#
# Scons will do preparatory steps (generating SConscript files from .pro files, creating local include directory and symlinking all headers from there, ...), compile files and install them.
#
# To clean the build, run `scons -c'. Please note that it will also _uninstall_ yade from $PREFIX!
#
# TODO:
#  1. [REMOVED] [DONE] retrieve target list and append install targets dynamically;
#  2. [DONE] configuration and option handling.
#  3. Have build.log with commands and all output...
#
# And as usually, clean up the code, get rid of workarounds and hacks etc.
import os,os.path,string,re,sys,shutil
import SCons
# SCons version numbers are needed a few times
# rewritten for python2.4
ver=[str(x) for x in SCons.__version__.split('.')]
for i in range(0,len(ver)):
	def any2num(x):
		if x in ('0123456789'): return x
		else: return '0'
	ver[i]="".join([any2num(x) for x in ver[i]])
	if len(ver[i])>2: ver[i]=ver[i][0:2]+"."+ver[i][2:]
sconsVersion=10000*float(ver[0])
if len(ver)>1: sconsVersion+=100*float(ver[1])
if len(ver)>2: sconsVersion+=float(ver[2])
# print sconsVersion
#

##########################################################################################
########## PROXY TO NEWER SCONS (DOWNLOADED IF NEEDED) ###################################
##########################################################################################
#print sconsVersion
if sconsVersion<9806.0 and not os.environ.has_key('NO_SCONS_GET_RECENT'):
	# sconsVersion<10200.0 
	# tgzParams=("http://dfn.dl.sourceforge.net/sourceforge/scons/scons-local-1.2.0.d20090223.tar.gz","/scons-local-1.2.0.d20090223")
	tgzParams=("http://heanet.dl.sourceforge.net/sourceforge/scons/scons-local-1.0.0.tar.gz","/scons-local-1.0.0")
	newPrefix="./scons-local";
	newUrl,newDir=tgzParams[0],newPrefix+"/"+tgzParams[1]
	if not os.path.exists(newDir):
		print "Scons version too old, downloading new version. All subsequent calls will be proxied to the new version transparently."
		import urllib,tarfile
		(filename,headers)=urllib.urlretrieve(newUrl)
		print filename,"\n",headers
		tar=tarfile.open(filename, "r:gz")
		for tarinfo in tar: tar.extract(tarinfo,newPrefix)
		print "Done extracting scons to",newDir
		assert(os.path.exists(newDir))
	if os.path.exists(newDir):
		Exit(os.execv(newPrefix+"/scons.py",[newPrefix+'/scons.py']+sys.argv[1:]))

##########################################################################################
############# OPTIONS ####################################################################
##########################################################################################

### hardy compatibility (may be removed at some later point probably)
### used only when building debian package, since at that point auto download of newer scons is disabled
if 'Variables' not in dir():
	Variables=Options
	BoolVariable,ListVariable,EnumVariable=BoolOption,ListOption,EnumOption

env=Environment(tools=['default','scanreplace'],toolpath=['scripts'])
profileFile='scons.current-profile'
env['sourceRoot']=os.getcwd()

profOpts=Variables(profileFile)
profOpts.Add(('profile','Config profile to use (predefined: default or ""); append ! to use it but not save for next build (in scons.current-profile)','default'))
profOpts.Update(env)
# multiple profiles - run them all at the same time
# take care not to save current profile for those parallel builds
if env['profile']=='': env['profile']='default'
# save the profile only if the last char is not !
saveProfile=True
if env['profile'][-1]=='!': env['profile'],noSaveProfile=env['profile'][:-1],False
if saveProfile: profOpts.Save(profileFile,env)

if env['profile']=='': env['profile']='default'
optsFile='scons.profile-'+env['profile']
profile=env['profile']
print '@@@ Using profile',profile,'('+optsFile+') @@@'

opts=Variables(optsFile)
## compatibility hack again
if 'AddVariables' not in dir(opts): opts.AddVariables=opts.AddOptions

def colonSplit(x): return x.split(':')

#
# The convention now is, that
#  1. CAPITALIZED options are
#   (a) notorious shell variables (they correspons most the time to SCons environment options of the same name - like CPPPATH)
#   (b) c preprocessor macros available to the program source (like PREFIX and SUFFIX)
#  2. lowercase options influence the building process, compiler options and the like.
#


opts.AddVariables(
	### OLD: use PathOption with PathOption.PathIsDirCreate, but that doesn't exist in 0.96.1!
	('PREFIX','Install path prefix','/usr/local'),
	('runtimePREFIX','Runtime path prefix; DO NOT USE, inteded for packaging only.',None),
	('variant','Build variant, will be suffixed to all files, along with version.','' if profile=='default' else '-'+profile,None,lambda x:x),
	BoolVariable('debug', 'Enable debugging information',0),
	BoolVariable('gprof','Enable profiling information for gprof',0),
	('optimize','Turn on optimizations (-1, 0 or 1); negative value sets optimization based on debugging: not optimize with debugging and vice versa.',-1,None,int),
	ListVariable('exclude','Yade components that will not be built','none',names=['gui','extra','common','dem','lattice','snow']),
	EnumVariable('PGO','Whether to "gen"erate or "use" Profile-Guided Optimization','',['','gen','use'],{'no':'','0':'','false':''},1),
	ListVariable('features','Optional features that are turned on','log4cxx,opengl,gts,openmp,vtk',names=['opengl','log4cxx','cgal','openmp','gts','vtk','python','gl2ps','devirt-functors','qt4','never_use_this_one']),
	('jobs','Number of jobs to run at the same time (same as -j, but saved)',2,None,int),
	#('extraModules', 'Extra directories with their own SConscript files (must be in-tree) (whitespace separated)',None,None,Split),
	('buildPrefix','Where to create build-[version][variant] directory for intermediary files','..'),
	('hotPlugins','Files (without the .cpp extension) that will be compiled separately even in the monolithic build (use for those that you modify frequently); comma-separated.',''),
	('chunkSize','Maximum files to compile in one translation unit when building plugins. (unlimited if <= 0, per-file linkage is used if 1)',7,None,int),
	('version','Yade version (if not specified, guess will be attempted)',None),
	('realVersion','Revision (usually bzr revision); guessed automatically unless specified',None),
	('CPPPATH', 'Additional paths for the C preprocessor (colon-separated)','/usr/include/vtk-5.0:/usr/include/vtk-5.2:/usr/include/vtk-5.4:/usr/include/vtk-5.6:/usr/include/eigen2:/usr/include/vtk'), # hardy has vtk-5.0
	('LIBPATH','Additional paths for the linker (colon-separated)',None),
	('libstdcxx','Specify libstdc++ location by hand (opened dynamically at startup), usually not needed',None),
	('QT4CXX','Specify a different compiler for files including qt4; this is necessary for older qt version (<=4.7) which don\'t compile with clang',None),
	('QT4DIR','Directory where Qt4 is installed','/usr/share/qt4'),
	('PATH','Path (not imported automatically from the shell) (colon-separated)',None),
	('CXX','The c++ compiler','g++'),
	('CXXFLAGS','Additional compiler flags for compilation (like -march=core2).',None,None,Split),
	('march','Architecture to use with -march=... when optimizing','native',None,None),
	BoolVariable('mono','[experimental] Build only one shared library and make all other files (python objects, for instance) only be symlinks.',0),
	('execCheck','Name of the main script that should be installed; if the current one differs, an erro is raised (do not use directly, only intended for --rebuild',None),
	('defThreads','Default number of OpenMP threads to run with, unless overridden with -j. Keep unset (negative) to default to using all cores.',-1),
	#('SHLINK','Linker for shared objects','g++'),
	('SHCCFLAGS','Additional compiler flags for linking (for plugins).',None,None,Split),
	BoolVariable('QUAD_PRECISION','typedef Real as long double (=quad)',0),
	BoolVariable('brief',"Don't show commands being run, only what files are being compiled/linked/installed",True),
)
opts.Update(env)

if str(env['features'])=='all':
	print 'ERROR: using "features=all" is illegal, since it breaks feature detection at runtime (SCons limitation). Write out all features separated by commas instead. Sorry.'
	Exit(1)

if saveProfile: opts.Save(optsFile,env)
# fix expansion in python substitution by assigning the right value if not specified
if not env.has_key('runtimePREFIX') or not env['runtimePREFIX']: env['runtimePREFIX']=env['PREFIX']
# set optimization based on debug, if required
if env['optimize']<0: env['optimize']=not env['debug']

# handle colon-separated lists:
for k in ('CPPPATH','LIBPATH','QTDIR','PATH'):
	if env.has_key(k):
		env[k]=colonSplit(env[k])

# do not propagate PATH from outside, to ensure identical builds on different machines
#env.Append(ENV={'PATH':['/usr/local/bin','/bin','/usr/bin']})
# ccache needs $HOME to be set, also CCACHE_PREFIX if used; colorgcc needs $TERM; distcc wants DISTCC_HOSTS
# fakeroot needs FAKEROOTKEY and LD_PRELOAD
propagatedEnvVars=['HOME','TERM','DISTCC_HOSTS','LD_PRELOAD','FAKEROOTKEY','LD_LIBRARY_PATH','CCACHE_PREFIX']
for v in propagatedEnvVars:
	if os.environ.has_key(v): env.Append(ENV={v:os.environ[v]})
if env.has_key('PATH'): env.Append(ENV={'PATH':env['PATH']})

# get number of jobs from DEB_BUILD_OPTIONS if defined
# see http://www.de.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
if os.environ.has_key('DEB_BUILD_OPTIONS'):
	for opt in os.environ['DEB_BUILD_OPTIONS'].split():
		if opt.startswith('parallel='):
			j=opt.split('=')[1].split(',')[0] # there was a case of 5, in hardy...
			print "Setting number of jobs (using DEB_BUILD_OPTIONS) to `%s'"%j
			env['jobs']=int(j)



if sconsVersion>9700: opts.FormatOptionHelpText=lambda env,opt,help,default,actual,alias: "%10s: %5s [%s] (%s)\n"%(opt,actual,default,help)
else: opts.FormatOptionHelpText=lambda env,opt,help,default,actual: "%10s: %5s [%s] (%s)\n"%(opt,actual,default,help)
Help(opts.GenerateHelpText(env))

###########################################
################# BUILD DIRECTORY #########
###########################################
import yadeSCons
## ALL generated stuff should go here - therefore we must determine it very early!!
if not env.has_key('realVersion') or not env['realVersion']: env['realVersion']=yadeSCons.getRealVersion() or 'unknown' # unknown if nothing returned
if not env.has_key('version'): env['version']=env['realVersion']

env['SUFFIX']='-'+env['version']+env['variant']
env['SUFFIX_DBG']=env['SUFFIX']+('' if not env['debug'] else '/dbg')
env['LIBDIR']='$PREFIX/lib/yade$SUFFIX_DBG'
print "Yade version is `%s' (%s), installed files will be suffixed with `%s'."%(env['version'],env['realVersion'],env['SUFFIX'])
buildDir=os.path.abspath(env.subst('$buildPrefix/build$SUFFIX_DBG'))
print "All intermediary files will be in `%s'."%env.subst(buildDir)
env['buildDir']=buildDir
# these MUST be first so that builddir's headers are read before any locally installed ones
buildInc='$buildDir/include'
env.Append(CPPPATH=[buildInc])

env.SConsignFile(buildDir+'/scons-signatures')

##########################################################################################

=== extra/mgpost/Makefile ===
##########################################################################
#  Copyright (C) 2008 by Vincent Richefeu                                #
#  vincent.richefeu@hmg.inpg.fr                                          #
#                                                                        #
#  This program is free software; it is licensed under the terms of the  #
#  GNU General Public License v2 or later. See file LICENSE for details. #
##########################################################################


INSTALL_DIR = /usr/local/bin

default: linux

macosx: src/*.c src/*.h
	${MAKE} -f Makefile.macosx -C src

windows: src/*.c src/*.h
	${MAKE} -f Makefile.windows -C src

linux: src/*.c src/*.h
	${MAKE} -f Makefile.linux -C src

clean:
	rm -f *~ \#*\# ; \
	rm -f ./mgpost ; \
	rm -f ./mgpost.exe ; \
	${MAKE} -f Makefile.linux -C src clean 

clean+: clean
	rm -f mgconf mgpalloc ; \
	${MAKE} -C doc clean 

install: linux
	sudo cp ./mgpost $(INSTALL_DIR) ; \

=== debian/changelog ===
yade (0.60.3-2) unstable; urgency=low

  * [67adc6c] Fix FTBFS on powerpc (Closes: #632503)

 -- Anton Gladky <gladky.anton@gmail.com>  Sat, 02 Jul 2011 15:08:46 +0200

yade (0.60.3-1) unstable; urgency=low

  * [1612906] Reduce the number of binary-packages twice.
  * [d8e097e] Imported Upstream version 0.60.3
  * [f5a454a] Delete patches, applied by upstream in 0.60.3 release.
  * [d29e6e4] Enable dbg-mode during man-genaration.

 -- Anton Gladky <gladky.anton@gmail.com>  Sun, 26 Jun 2011 21:32:16 +0200

yade (0.60.2-5) unstable; urgency=low

  * [ed48b2f] Fix FTBFS on kFreeBSD and other platforms, 
      where was an error during checking qglviwer (Closes: #628376)
  * [608c086] Fix generation manpage error on powerpc and sparc.
  * [093fe7b] Fix compilation with eigen3.
  * [4d7707d] Use eigen3 instead of eigen2.
  * [f34dd24] Test at first debug-version, then optimized to find out the 
    reason of problem before crash.
  * [3a76893] Add CXXFLAGS from dpkg-buildflag.
  * [321dced] Generate manpages in debug-mode.

 -- Anton Gladky <gladky.anton@gmail.com>  Fri, 10 Jun 2011 21:54:25 +0200

yade (0.60.2-4) unstable; urgency=low

  * [d1acf0c] Prevent building docs in binary-arch mode.
  * [d1acf0c] Reduce RAM consumption to minimal during build process.
  * [22b92eb] Output an information about available memory and CPU before 
      building.
  * [2adcf6a] Let binutils-gold to be used only on amd64 and i386 platforms.

 -- Anton Gladky <gladky.anton@gmail.com>  Tue, 24 May 2011 20:11:58 +0200

yade (0.60.2-3) unstable; urgency=low

  * [9fb84aa] Hopefully fix FTBFS on most of 
      platforms due to MPLCONFIGDIR (Closes: #626722)
  * [c58a0fa] Update debian/rules, dh7.
  * [0c163b1] Update to Standards-Version: 3.9.2 (no changes).
  * [cc8714c] Raise up python-sphinx required version to 1.0.5.
  * [b045d3b] Move mencoder from "Depends" to "Recommends" to make
      yade installable on non-graphic systems.
  * [94ebfd7] Fix in postinst for correct alias of man-pages.

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 11 May 2011 19:52:26 +0200

yade (0.60.2-2) unstable; urgency=low

  * [6ee4fb7] Remove binutils-gold (only on platforms, where it is 
      not available) and clang from BD (Closes: #623427)
  * [353bf83] Change chunkSize=3 to decrease RAM consumption during build.
  * [de16760] Change long list of commands in binary-arch to _dh binary-arch_
  * [fa12839] Enable binutils-gold on platforms, where it is available.
  * [5d2ac1e] Increase debhelper version number for BD to 7.0.50.
  * [abd1f59] Add dh binary-indep.
  * [fccb8c8] Fix crash, when force applied to non existing body.
  * [70d3b9e] Added syncSizesOfContainers to forceContainer.

 -- Anton Gladky <gladky.anton@gmail.com>  Fri, 22 Apr 2011 14:01:08 +0200

yade (0.60.2-1) unstable; urgency=low

  * New upstream release 0.60.2
  * Fixed memory leak in InsertionSortCollider (LP: #721107)
  * Fixed crash after adding particles in parallel mode (LP: #724396)
  * Fixed problem with linking libraries on Natty (LP: #707966)
  * vtkNetCDF was deleted from libs due to absence in libvtk5.6-dev
  * jquery.js in documentation is now symlink to a packaged jquery,
      if it is available.
  * openmp-mode is turned on in build options.
  * liblog4cxx9-dev was deleted from dependencies, as
      "liblog4cxx9-dev | liblog4cxx10-dev" is not working on most of
      platforms. liblog4cxx10-dev is ignored in this case.
      http://lists.debian.org/debian-devel/2011/02/msg00738.html
  * migrated from expetimental to unstable, because python-sphinx
      1.0.7 is already in sid as well.

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 13 Apr 2011 00:32:18 +0100

yade (0.60-1) experimental; urgency=low

  * Initial import (Closes: #608663)

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 19 Jan 2011 17:05:02 +0000

=== debian/control ===
Source: yade
Section: science
Priority: extra
Homepage: https://launchpad.net/yade
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladky.anton@gmail.com>
DM-Upload-Allowed: yes
Vcs-Git: git://git.debian.org/git/debian-science/packages/yade.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/yade.git
Build-Depends: debhelper (>= 7.0.50~), scons, binutils-gold [amd64 i386], 
 freeglut3-dev, libboost-dev (>=1.35), libboost-date-time-dev (>=1.35), 
 libboost-filesystem-dev (>=1.35), libboost-thread-dev (>=1.35), 
 libboost-regex-dev (>=1.35), libboost-python-dev (>=1.35),
 libboost-iostreams-dev (>=1.35), libboost-program-options-dev, python-support,
 libboost-serialization-dev, libloki-dev, liblog4cxx10-dev,
 docbook-to-man, ipython, libgts-dev, python-numpy, g++(>>4.0), libvtk5-dev, 
 libgl1-mesa-dev, gdb, python-matplotlib, python-tk, libeigen3-dev, 
 libqglviewer-qt4-dev, python-xlib, python-qt4, pyqt4-dev-tools, python-imaging
Build-Depends-Indep: texlive-latex-recommended, texlive-latex-extra, lmodern, 
 texlive-pictures, texlive-xetex, libjs-jquery, python-sphinx (>=1.0.6),
 python-bibtex, graphviz, dvipng
Standards-Version: 3.9.2

Package: yade
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-numpy, ipython,
 python-matplotlib, python-tk, python-qt4, python-xlib, gnuplot, python-imaging, libjs-jquery
Recommends: mencoder
Description: Platform for discrete element modeling. Main optimized build
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models, 
 focused on Discrete Element Method. 
 The computation parts are written in c++ using flexible object model, 
 allowing independent implementation of new algorithms and interfaces. 
 Python is used for rapid and concise scene construction, 
 simulation control, postprocessing and debugging.
 .
 This package contains speed-optimized build of yade.

Package: yade-dbg
Architecture: any
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends}, yade
Description: Platform for discrete element modeling. Debug build
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models, 
 focused on Discrete Element Method. 
 The computation parts are written in c++ using flexible object model, 
 allowing independent implementation of new algorithms and interfaces. 
 Python is used for rapid and concise scene construction, 
 simulation control, postprocessing and debugging.
 .
 This package contains debug build of yade.

Package: yade-doc
Architecture: all
Section: doc
Recommends: yade
Depends: ${misc:Depends}, libjs-jquery
Description: Platform for discrete element modeling. Documentation
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models, 
 focused on Discrete Element Method. 
 The computation parts are written in c++ using flexible object model, 
 allowing independent implementation of new algorithms and interfaces. 
 Python is used for rapid and concise scene construction, 
 simulation control, postprocessing and debugging.
 .
 This package contains examples, test scripts and documentation.

=== debian/rules ===
#!/usr/bin/make -f

tmpDirMatplotLib = $(CURDIR)/debian/matplotlib
tmpInstall = $(CURDIR)/debian/inst
tmpInstallDbg = $(CURDIR)/debian/inst-dbg
CXXFLAGS := -Wall $(shell dpkg-buildflags --get CXXFLAGS)

%:
	dh $@

override_dh_auto_clean:
	rm -rf debian/build
	rm -rf doc/sphinx/_build
	rm -rf tags
	rm -f scons.*
	rm -f *.1
	rm -rf $(tmpDirMatplotLib)
	rm -rf $(tmpInstall)
	rm -rf $(tmpInstallDbg)
	find . -name '*.pyc' -print0 | xargs -0 rm -f
	dh_clean 

override_dh_auto_configure:
	mkdir -p $(tmpDirMatplotLib)
	mkdir -p $(tmpInstall)
	mkdir -p $(tmpInstallDbg)

override_dh_auto_build:
	# remove the profile, if existing, to have clean config
	rm -f scons.*
	#Output an information about available memory and CPU
	-cat /proc/meminfo
	-cat /proc/cpuinfo
	# the last argument specified that we only want files in lib installed -- common files (the executable) are already in the optimized package
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib)$ ; NO_SCONS_GET_RECENT= scons profile=deb buildPrefix=debian runtimePREFIX=/usr version='' brief=0 chunkSize=2 features=vtk,gts,opengl,qt4,openmp PREFIX=$(tmpInstallDbg) variant='' CXXFLAGS='$(CXXFLAGS)' optimize=0 -j1 march= debug=1 
	#optimized build
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; NO_SCONS_GET_RECENT= scons profile=deb PREFIX=$(tmpInstall) variant=''  -j1 optimize=1 debug=0
	# generate manpages
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstallDbg) $(tmpInstallDbg)/bin/yade --debug --generate-manpage yade.1
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade-batch --generate-manpage yade-batch.1

override_dh_auto_test:
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstallDbg) $(tmpInstall)/bin/yade --debug --test
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade --test
	#Delete all pyc files
	find . -name '*.pyc' -print0 | xargs -0 rm -f

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_installman:
	dh_installman -p yade yade.1 yade-batch.1

override_dh_strip:
	dh_strip --exclude=yade-dbg   # don't strip the debug package

override_dh_compress:
	dh_compress --all -X.py -X.stl -X.gts -X.geo -X.mesh -X.msh -X.pdf -X.png -X.svg -X.txt -X.js -X.inv

binary-indep: 
	dh --until dh_auto_build $@
	#Generate docs
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; cd doc/sphinx; PYTHONPATH=. YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade yadeSphinx.py; cd _build/latex; xelatex Yade.tex; xelatex Yade.tex; xelatex Yade.tex;
	dh --after dh_auto_build $@
	
binary-arch: 
	dh $@

binary: binary-indep binary-arch

## yade 0.70.0

=== CMakeLists.txt ===
# cmake build file for yade
# the way to build yade
# 1. gather all source files in chunks (using COMBINE_SOURCES) that will be compiled together
#    (otherwise each source file would be compiled separately, which is too slow)
#    Unlike in scons compilations, also python modules are gathered in chunks.
# 2. create yade-all library that is compiled from all the chunks
# 3. Create symlinks pointing to yade-all for all python modules we want to create
#    (this will have to be 
#
#
project(Yade C CXX)
cmake_minimum_required(VERSION 2.8)

include(FindPythonLibs)
include(FindPythonInterp)
include(FindOpenMP)
include(FindOpenGL)
include(FindQt4)
include(FindBoost)
include(FindVTK)
include(FindPkgConfig)
include(FeatureSummary)

find_package(Boost COMPONENTS python thread date_time filesystem iostreams regex serialization)
find_package(Qt4 COMPONENTS QtCore QtGgui QtOpenGL)
find_package(VTK COMPONENTS Common REQUIRED) 

add_definitions(-DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast)

IF (NOT LIB_EIGEN_PATH)
 SET(LIB_EIGEN_PATH "/usr/include/eigen2")
 MESSAGE("Headers of eigen library will be included from  ${LIB_EIGEN_PATH}, if you want to override it use -DLIB_EIGEN_PATH option.")
ENDIF (NOT LIB_EIGEN_PATH)

INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${LIB_EIGEN_PATH})
INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/extra/floating_point_utilities_v3)

find_path(CGAL_INCLUDE_DIR CGAL/Exact_predicates_inexact_constructions_kernel.h REQUIRED)
find_library(CGAL_FOUND CGAL)
if(${CGAL_FOUND})
	add_definitions(-frounding-math)
	INCLUDE_DIRECTORIES(${CGAL_INCLUDE_DIR})
endif()

pkg_search_module(GTS gts)

# ccache distcc clang++: must check compiler and its first 2 "args"
if((CMAKE_CXX_COMPILER MATCHES ".*clang.*") OR (CMAKE_CXX_COMPILER_ARG1 MATCHES ".*clang.*") OR (CMAKE_CXX_COMPILER_ARG2 MATCHES ".*clang.*"))
	add_definitions(-Wno-unused-variable -Wno-mismatched-tags -Wno-constant-logical-operand -Qunused-arguments -Wno-empty-body)
	MESSAGE("Using clang, suppressing some warnings.")
endif()
	

#set(CMAKE_VERBOSE_MAKEFILE 1)

IF (NOT CHUNKSIZE)
 SET(CHUNKSIZE 100)
 MESSAGE("Maximum files to compile in one translation unit ${CHUNKSIZE}, if you want to override it use -DCHUNKSIZE option.")
ENDIF (NOT CHUNKSIZE)


IF (NOT INSTALL_PREFIX)
 SET(CMAKE_INSTALL_PREFIX "/usr/local")
 MESSAGE("Yade will be installed to default path ${CMAKE_INSTALL_PREFIX}, if you want to override it use -DINSTALL_PREFIX option.")
ELSE (NOT INSTALL_PREFIX)
	SET(CMAKE_INSTALL_PREFIX ${INSTALL_PREFIX})
	MESSAGE("Yade will be installed to ${CMAKE_INSTALL_PREFIX}")
ENDIF (NOT CMAKE_INSTALL_PREFIX)


SET(YADE_LIB_PATH ${CMAKE_INSTALL_PREFIX}/lib/yade-${SUFFIX})
SET(YADE_EXEC_PATH ${CMAKE_INSTALL_PREFIX}/bin)
SET(YADE_PY_PATH ${YADE_LIB_PATH}/py)

#"OPENMP" 
FOREACH(FEAT "OPENGL" "VTK" "LOG4CXX" "GTS" "CGAL")
	if("${FEAT}_FOUND")
		add_definitions(-DYADE_${FEAT})
		message("Feature ${FEAT} enabled")
	endif()
ENDFOREACH()
PRINT_ENABLED_FEATURES()
PRINT_DISABLED_FEATURES()

# this is only a temporary hack, headers should be installed in the build-dir directly
# perhaps there is a proper way, have to ask
if(NOT EXISTS "${CMAKE_BINARY_DIR}/yade")
	EXECUTE_PROCESS(COMMAND ln -s ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}/yade)
endif()
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})


# include several source files (in SRCS) in one or more
# combined files; each combined file holds maximally 
# MAXNUM files.
# BASE gives basename for created files;
# files corresponding to the pattern are deleted
# first, so that there are no relicts from previous runs
# with possibly different MAXNUM
MACRO(COMBINE_SOURCES BASE SRCS MAXNUM)
	LIST(LENGTH SRCS SRCS_LENGTH)
	SET(COMB_COUNTER 0)
	FILE(GLOB EXISTING "${BASE}.*.cpp")
	IF("$EXISTING")
		FILE(REMOVE ${EXISTING})
	ENDIF()
	SET(OUT "${BASE}.${COMB_COUNTER}.cpp")
	FILE(WRITE ${OUT})
	SET(COUNTER 0)
	FOREACH(SRC ${SRCS})
		if(${SRC} MATCHES "^/.*$") # absolute filename
			FILE(APPEND ${OUT} "#include<${SRC}>\n")
		else()
			FILE(APPEND ${OUT} "#include<${CMAKE_SOURCE_DIR}/${SRC}>\n")
		endif()
		MATH(EXPR COUNTER "${COUNTER}+1")
		IF(${COUNTER} EQUAL ${MAXNUM})
			SET(COUNTER 0)
			MATH(EXPR COMB_COUNTER ${COMB_COUNTER}+1)
			SET(OUT "${BASE}.${COMB_COUNTER}.cpp")
			FILE(WRITE ${OUT})
		ENDIF()
	ENDFOREACH()
ENDMACRO()

FILE(GLOB         SRC_CORE "core/*.cpp")
FILE(GLOB_RECURSE SRC_PKG "pkg/*.cpp")
# without lib/, will be added below
SET(SRC_LIB "lib/base/Math.cpp;lib/factory/ClassFactory.cpp;lib/factory/DynLibManager.cpp;lib/multimethods/Indexable.cpp;lib/serialization/Serializable.cpp;lib/pyutil/gil.cpp")
IF(${CGAL_FOUND})
	SET(SRC_LIB "${SRC_LIB};lib/triangulation/KinematicLocalisationAnalyser.cpp;lib/triangulation/Operations.cpp;lib/triangulation/RegularTriangulation.cpp;lib/triangulation/Timer.cpp;lib/triangulation/basicVTKwritter.cpp;lib/triangulation/FlowBoundingSphere.cpp;lib/triangulation/Network.cpp;lib/triangulation/Deformation.cpp;lib/triangulation/Empilement.cpp;lib/triangulation/stdafx.cpp;lib/triangulation/Tenseur3.cpp;lib/triangulation/Tesselation.cpp;lib/triangulation/TriaxialState.cpp")
ENDIF()
IF(${OPENGL_FOUND})
	SET(SRC_LIB "${SRC_LIB};lib/opengl/GLUtils.cpp")
ENDIF()

# the last number is "chunkSize"
COMBINE_SOURCES(${CMAKE_BINARY_DIR}/core "${SRC_CORE}" 1000)
COMBINE_SOURCES(${CMAKE_BINARY_DIR}/pkg "${SRC_PKG}" ${CHUNKSIZE})
COMBINE_SOURCES(${CMAKE_BINARY_DIR}/lib "${SRC_LIB}" ${CHUNKSIZE})
FILE(GLOB SRC_CORE_COMBINED "${CMAKE_BINARY_DIR}/core.*.cpp")
FILE(GLOB SRC_PKG_COMBINED  "${CMAKE_BINARY_DIR}/pkg.*.cpp")
FILE(GLOB SRC_LIB_COMBINED  "${CMAKE_BINARY_DIR}/lib.*.cpp")

#add_library(core SHARED ${SRC_CORE_COMBINED})
#add_library(pkg SHARED ${SRC_PKG_COMBINED})
#add_library(support SHARED ${SRC_LIB_COMBINED})
#target_link_libraries(core support)
#target_link_libraries(pkg core)
SET(SRC_PYMODULES py/WeightedAverage2d.cpp;py/_eudoxos.cpp;py/log.cpp;py/_utils.cpp;py/wrapper/customConverters.cpp)

SET(SRC_PACK ${CMAKE_SOURCE_DIR}/py/pack/_packPredicates.cpp;${CMAKE_SOURCE_DIR}/py/pack/_packObb.cpp;${CMAKE_SOURCE_DIR}/py/pack/_packSpheres.cpp) # ;${CMAKE_SOURCE_DIR}/py/pack/_packSpherePadder.cpp;${CMAKE_SOURCE_DIR}/py/pack/SpherePadder/SpherePadder.cpp;${CMAKE_SOURCE_DIR}/py/pack/SpherePadder/TetraMesh.cpp;${CMAKE_SOURCE_DIR}/py/pack/SpherePadder/CellPartition.cpp
#IF(${CGAL_FOUND})
#	SET(SRC_PACK ${SRC_PACK};${CMAKE_SOURCE_DIR}/py/pack/SpherePadder/SpherePackingTriangulation.cpp)
#ENDIF()

COMBINE_SOURCES(${CMAKE_BINARY_DIR}/pyPack "${SRC_PACK}" 100)
SET(SRC_PACK_COMBINED "${CMAKE_BINARY_DIR}/pyPack.0.cpp")
#add_library(pyPack STATIC ${CMAKE_BINARY_DIR}/pyPack.0.cpp)
#add_library(pyWrapper STATIC py/wrapper/yadeWrapper.cpp)

COMBINE_SOURCES(${CMAKE_BINARY_DIR}/pyModules "${SRC_PYMODULES}" 100)
FILE(GLOB SRC_PYMODULES_COMBINED "${CMAKE_BINARY_DIR}/pyModules.*.cpp")
#add_library(pyModules SHARED ${SRC_PYMODULES_COMBINED})
#target_link_libraries(pyModules pyWrapper pyPack pyEigen _gts)

# will be different for debugging builds!
SET(YADE_LIBDIR lib/yade${YADE_SUFFIX})

SET(SRC_PYGTS "py/3rd-party/pygts-0.3.1/cleanup.c;py/3rd-party/pygts-0.3.1/edge.c;py/3rd-party/pygts-0.3.1/face.c;py/3rd-party/pygts-0.3.1/object.c;py/3rd-party/pygts-0.3.1/point.c;py/3rd-party/pygts-0.3.1/pygts.c;py/3rd-party/pygts-0.3.1/segment.c;py/3rd-party/pygts-0.3.1/surface.c;py/3rd-party/pygts-0.3.1/triangle.c;py/3rd-party/pygts-0.3.1/vertex.c")


SET(YADE_ALL_SRCS ${SRC_CORE_COMBINED};${SRC_PKG_COMBINED};${SRC_LIB_COMBINED};${SRC_PYMODULES_COMBINED};${SRC_PACK_COMBINED};${SRC_PYGTS};py/mathWrap/miniEigen.cpp)

python_add_module(yade-all "${YADE_ALL_SRCS}")

IF(${GTS_FOUND})
	#add_library(_gts STATIC py/3rd-party/pygts-0.3.1/cleanup.c;py/3rd-party/pygts-0.3.1/edge.c;py/3rd-party/pygts-0.3.1/face.c;py/3rd-party/pygts-0.3.1/object.c;py/3rd-party/pygts-0.3.1/point.c;py/3rd-party/pygts-0.3.1/pygts.c;py/3rd-party/pygts-0.3.1/segment.c;py/3rd-party/pygts-0.3.1/surface.c;py/3rd-party/pygts-0.3.1/triangle.c;py/3rd-party/pygts-0.3.1/vertex.c)
	include_directories(${GTS_INCLUDE_DIRS})
	add_definitions(-DPYGTS_HAS_NUMPY)
	# see http://www.mail-archive.com/cmake@cmake.org/msg24812.html
	#set_target_properties(_gts
	#	PROPERTIES COMPILE_FLAGS "-Wno-all"
	#	COMPILE_DEFINES -DPYGTS_HAS_NUMPY )
	FOREACH(_libname ${GTS_LIBRARIES})
		target_link_libraries(yade-all ${_libname})
	ENDFOREACH()
ENDIF()

## add_library(pyEigen STATIC py/mathWrap/miniEigen.cpp)


SET(PY_COMPILED_MODULES mathWrap;gts/_gts;yade/boot;yade/log;yade/wrapper;yade/_customConverters;yade/_eudoxos;yade/_packPredicates;yade/_packSpheres;yade/_packObb;yade/_utils;yade/WeightedAverage2d) # ;yade/_packSpherePadder
IF(${QT4_FOUND})
	SET(PY_COMPILED_MODULES ${PY_COMPILED_MODULES};yade/qt/_GLViewer)
ENDIF()


install(TARGETS yade-all DESTINATION ${YADE_LIB_PATH})

FOREACH(_mod ${PY_COMPILED_MODULES})
	install(CODE "EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink ${YADE_LIB_PATH}/libyade-all.so ${YADE_PY_PATH}/${_mod}.so)")
ENDFOREACH()


# install our python scripts, keeping the hierarchy under py/
install(DIRECTORY py/ DESTINATION ${YADE_PY_PATH}
	FILES_MATCHING PATTERN "*.py"
	PATTERN "3rd-party" EXCLUDE
)

# install 3rd party python files
install(FILES py/3rd-party/pygts-0.3.1/__init__.py DESTINATION ${YADE_LIB_PATH}/gts)
install(FILES py/3rd-party/pygts-0.3.1/pygts.py DESTINATION ${YADE_LIB_PATH}/gts)
install(FILES py/3rd-party/mtTkinter-0.3/mtTkinter.py DESTINATION ${YADE_LIB_PATH})

# install the files that need to be pre-processed (FIXME: this will need to define all variables, and call them the same as they are in scons -- for compatibility)
configure_file(core/main/yade-batch.in ${YADE_EXEC_PATH}/yade-batch-${SUFFIX})
configure_file(core/main/main.py.in ${YADE_EXEC_PATH}/yade-${SUFFIX})
configure_file(py/config.py.in ${YADE_PY_PATH}/yade/config.py)

=== SConstruct ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#!/usr/bin/scons
+#!/usr/bin/scon
 # coding: UTF-8
 # vim:syntax=python:
 
@@ -39,28 +39,6 @@
 #
 
 ##########################################################################################
-########## PROXY TO NEWER SCONS (DOWNLOADED IF NEEDED) ###################################
-##########################################################################################
-#print sconsVersion
-if sconsVersion<9806.0 and not os.environ.has_key('NO_SCONS_GET_RECENT'):
-	# sconsVersion<10200.0 
-	# tgzParams=("http://dfn.dl.sourceforge.net/sourceforge/scons/scons-local-1.2.0.d20090223.tar.gz","/scons-local-1.2.0.d20090223")
-	tgzParams=("http://heanet.dl.sourceforge.net/sourceforge/scons/scons-local-1.0.0.tar.gz","/scons-local-1.0.0")
-	newPrefix="./scons-local";
-	newUrl,newDir=tgzParams[0],newPrefix+"/"+tgzParams[1]
-	if not os.path.exists(newDir):
-		print "Scons version too old, downloading new version. All subsequent calls will be proxied to the new version transparently."
-		import urllib,tarfile
-		(filename,headers)=urllib.urlretrieve(newUrl)
-		print filename,"\n",headers
-		tar=tarfile.open(filename, "r:gz")
-		for tarinfo in tar: tar.extract(tarinfo,newPrefix)
-		print "Done extracting scons to",newDir
-		assert(os.path.exists(newDir))
-	if os.path.exists(newDir):
-		Exit(os.execv(newPrefix+"/scons.py",[newPrefix+'/scons.py']+sys.argv[1:]))
-
-##########################################################################################
 ############# OPTIONS ####################################################################
 ##########################################################################################
 
@@ -112,10 +90,9 @@
 	('variant','Build variant, will be suffixed to all files, along with version.','' if profile=='default' else '-'+profile,None,lambda x:x),
 	BoolVariable('debug', 'Enable debugging information',0),
 	BoolVariable('gprof','Enable profiling information for gprof',0),
-	('optimize','Turn on optimizations (-1, 0 or 1); negative value sets optimization based on debugging: not optimize with debugging and vice versa.',-1,None,int),
-	ListVariable('exclude','Yade components that will not be built','none',names=['gui','extra','common','dem','lattice','snow']),
+	('optimize','Turn on optimizations (-1, 0 or 1); with negative value (-1) optimization is based on debugging: not optimize with debugging (debug=True <=> optimize=False) and vice versa. With positive values optimization is performed (case of 1) or not (0) independent of debugging',-1,None,int),
 	EnumVariable('PGO','Whether to "gen"erate or "use" Profile-Guided Optimization','',['','gen','use'],{'no':'','0':'','false':''},1),
-	ListVariable('features','Optional features that are turned on','log4cxx,opengl,gts,openmp,vtk',names=['opengl','log4cxx','cgal','openmp','gts','vtk','python','gl2ps','devirt-functors','qt4','never_use_this_one']),
+	ListVariable('features','Optional features that are turned on','log4cxx,opengl,gts,openmp,vtk,qt4',names=['opengl','log4cxx','cgal','openmp','gts','vtk','gl2ps','qt4','sphere-padder','never_use_this_one','subdomains']),
 	('jobs','Number of jobs to run at the same time (same as -j, but saved)',2,None,int),
 	#('extraModules', 'Extra directories with their own SConscript files (must be in-tree) (whitespace separated)',None,None,Split),
 	('buildPrefix','Where to create build-[version][variant] directory for intermediary files','..'),
@@ -123,7 +100,7 @@
 	('chunkSize','Maximum files to compile in one translation unit when building plugins. (unlimited if <= 0, per-file linkage is used if 1)',7,None,int),
 	('version','Yade version (if not specified, guess will be attempted)',None),
 	('realVersion','Revision (usually bzr revision); guessed automatically unless specified',None),
-	('CPPPATH', 'Additional paths for the C preprocessor (colon-separated)','/usr/include/vtk-5.0:/usr/include/vtk-5.2:/usr/include/vtk-5.4:/usr/include/vtk-5.6:/usr/include/eigen2:/usr/include/vtk'), # hardy has vtk-5.0
+	('CPPPATH', 'Additional paths for the C preprocessor (colon-separated)','/usr/include/vtk-5.0:/usr/include/vtk-5.2:/usr/include/vtk-5.4:/usr/include/vtk-5.6:/usr/include/vtk'), # hardy has vtk-5.0
 	('LIBPATH','Additional paths for the linker (colon-separated)',None),
 	('libstdcxx','Specify libstdc++ location by hand (opened dynamically at startup), usually not needed',None),
 	('QT4CXX','Specify a different compiler for files including qt4; this is necessary for older qt version (<=4.7) which don\'t compile with clang',None),
@@ -132,9 +109,8 @@
 	('CXX','The c++ compiler','g++'),
 	('CXXFLAGS','Additional compiler flags for compilation (like -march=core2).',None,None,Split),
 	('march','Architecture to use with -march=... when optimizing','native',None,None),
-	BoolVariable('mono','[experimental] Build only one shared library and make all other files (python objects, for instance) only be symlinks.',0),
-	('execCheck','Name of the main script that should be installed; if the current one differs, an erro is raised (do not use directly, only intended for --rebuild',None),
-	('defThreads','Default number of OpenMP threads to run with, unless overridden with -j. Keep unset (negative) to default to using all cores.',-1),
+	('execCheck','Name of the main script that should be installed; if the current one differs, an error is raised (do not use directly, only intended for --rebuild',None),
+	('defThreads','No longer used, specify -j each time yade is run (defaults to 1 now)',-1),
 	#('SHLINK','Linker for shared objects','g++'),
 	('SHCCFLAGS','Additional compiler flags for linking (for plugins).',None,None,Split),
 	BoolVariable('QUAD_PRECISION','typedef Real as long double (=quad)',0),
@@ -145,6 +121,27 @@
 if str(env['features'])=='all':
 	print 'ERROR: using "features=all" is illegal, since it breaks feature detection at runtime (SCons limitation). Write out all features separated by commas instead. Sorry.'
 	Exit(1)
+
+#Clean eigen directories
+if env.has_key('CPPPATH'):
+	cpppathes=colonSplit(env['CPPPATH'])
+	env['CPPPATH'] = ''
+	z=0
+	for i in cpppathes:
+		if (i[:-1] <> '/usr/include/eigen'):
+			if (z==0):
+				env.Append(CPPPATH=i)
+			else:
+				env.Append(CPPPATH=":"+i)
+			z+=1
+
+#Check, is there eigen3 directory, if not - use eigen2
+if os.path.exists('/usr/include/eigen3'):
+	print "Eigen 3 math library will be used"
+	env.Append(CPPPATH=":/usr/include/eigen3")
+else:
+	print "Eigen 2 math library will be used"
+	env.Append(CPPPATH=":/usr/include/eigen2")
 
 if saveProfile: opts.Save(optsFile,env)
 # fix expansion in python substitution by assigning the right value if not specified
@@ -189,7 +186,7 @@
 if not env.has_key('realVersion') or not env['realVersion']: env['realVersion']=yadeSCons.getRealVersion() or 'unknown' # unknown if nothing returned
 if not env.has_key('version'): env['version']=env['realVersion']
 
-env['SUFFIX']='-'+env['version']+env['variant']
+env['SUFFIX']=('-'+env['version'] if len(env['version'])>0 else '')+env['variant']
 env['SUFFIX_DBG']=env['SUFFIX']+('' if not env['debug'] else '/dbg')
 env['LIBDIR']='$PREFIX/lib/yade$SUFFIX_DBG'
 print "Yade version is `%s' (%s), installed files will be suffixed with `%s'."%(env['version'],env['realVersion'],env['SUFFIX'])
@@ -203,3 +200,18 @@
 env.SConsignFile(buildDir+'/scons-signatures')
 
 ##########################################################################################
+############# SHORTCUT TARGETS ###########################################################
+##########################################################################################
+
+if len(sys.argv)>1 and ('clean' in sys.argv) or ('tags' in sys.argv) or ('doc' in sys.argv):
+	if 'clean' in sys.argv:
+		if os.path.exists(buildDir):
+			print "Cleaning: %s."%buildDir; shutil.rmtree(buildDir)
+		else: print "Nothing to clean: %s."%buildDir
+		sys.argv.remove('clean')
+	if 'tags' in sys.argv:
+		cmd="ctags -R --extra=+q --fields=+n --exclude='.*' --exclude=attic --exclude=doc --exclude=scons-local --exclude=include --exclude=lib/triangulation --exclude=debian --exclude='*.so' --exclude='*.s' --exclude='*.ii' --langmap=c++:+.inl,c++:+.tpp,c++:+.ipp"
+		print cmd; os.system(cmd)
+		sys.argv.remove('tags')
+	if 'doc' in sys.argv:
+		raise RuntimeError("'doc' argument not supported by scons now. See doc/README")

=== debian/changelog ===
yade (0.70.0-5) unstable; urgency=low

  * [db2c9f6] Add gtk2-engines-pixbuf to depends section.
  * [a563b30] Use Standards-Version: 3.9.3. No changes.
  * [4454d5d] Small fixes due to ipython 0.12 migration.

 -- Anton Gladky <gladky.anton@gmail.com>  Tue, 03 Apr 2012 21:43:00 +0200

yade (0.70.0-4) unstable; urgency=high

  * [ef20192] fix FTBFS with boost >=1.47. (Closes: #653817)

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 04 Jan 2012 19:55:06 +0100

yade (0.70.0-3) unstable; urgency=low

  * [b9c8f44] Fix compilation with vtk-5.8.
  * [96fcd70] Update description in control-file.
  * [6c19037] Provide ipython-0.11 compatibility. (Closes: #636475)
  * [22291a8] Disable PDF-creation (does not build for the moment).

 -- Anton Gladky <gladky.anton@gmail.com>  Fri, 25 Nov 2011 20:34:24 +0100

yade (0.70.0-2) unstable; urgency=low

  * [8466b41] Remove yade-dbg binary, it is too large (about 200mb)
              and is not mandatory.

 -- Anton Gladky <gladky.anton@gmail.com>  Sat, 12 Nov 2011 16:52:57 +0100

yade (0.70.0-1) unstable; urgency=low

  * [989698e] Imported Upstream version 0.70.0
  * [0e11326] Replace underscore.js by the link on packaged version
  * [8c9464e] Add more tests to dh_auto_test (--check option).
  * [91e1e53] Add some more names to copyright-file.
  * [5a86e34] Provide a tight dependency for python-version. 
    (Closes: #642938)

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 26 Oct 2011 00:30:10 +0200

=== debian/control ===
--- 
+++ 
@@ -11,22 +11,25 @@
  freeglut3-dev, libboost-dev (>=1.35), libboost-date-time-dev (>=1.35), 
  libboost-filesystem-dev (>=1.35), libboost-thread-dev (>=1.35), 
  libboost-regex-dev (>=1.35), libboost-python-dev (>=1.35),
- libboost-iostreams-dev (>=1.35), libboost-program-options-dev, python-support,
- libboost-serialization-dev, libloki-dev, liblog4cxx10-dev,
+ libboost-iostreams-dev (>=1.35), libboost-program-options-dev, 
+ python-support, libboost-serialization-dev, libloki-dev, 
  docbook-to-man, ipython, libgts-dev, python-numpy, g++(>>4.0), libvtk5-dev, 
  libgl1-mesa-dev, gdb, python-matplotlib, python-tk, libeigen3-dev, 
  libqglviewer-qt4-dev, python-xlib, python-qt4, pyqt4-dev-tools, python-imaging
 Build-Depends-Indep: texlive-latex-recommended, texlive-latex-extra, lmodern, 
  texlive-pictures, texlive-xetex, libjs-jquery, python-sphinx (>=1.0.6),
- python-bibtex, graphviz, dvipng
-Standards-Version: 3.9.2
+ python-bibtex, graphviz, dvipng, libjs-underscore
+Standards-Version: 3.9.3
 
 Package: yade
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-numpy, ipython,
- python-matplotlib, python-tk, python-qt4, python-xlib, gnuplot, python-imaging, libjs-jquery
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
+ python (>= 2.7), python (<<2.8), 
+ python-numpy, ipython, python-matplotlib, python-tk, python-qt4, 
+ python-xlib, gnuplot, python-imaging, libjs-jquery, libjs-underscore,
+ gtk2-engines-pixbuf
 Recommends: mencoder
-Description: Platform for discrete element modeling. Main optimized build
+Description: Platform for discrete element modeling
  Yet Another Dynamic Engine.
  .
  Extensible open-source framework for discrete numerical models, 
@@ -37,22 +40,6 @@
  simulation control, postprocessing and debugging.
  .
  This package contains speed-optimized build of yade.
-
-Package: yade-dbg
-Architecture: any
-Section: debug
-Depends: ${shlibs:Depends}, ${misc:Depends}, yade
-Description: Platform for discrete element modeling. Debug build
- Yet Another Dynamic Engine.
- .
- Extensible open-source framework for discrete numerical models, 
- focused on Discrete Element Method. 
- The computation parts are written in c++ using flexible object model, 
- allowing independent implementation of new algorithms and interfaces. 
- Python is used for rapid and concise scene construction, 
- simulation control, postprocessing and debugging.
- .
- This package contains debug build of yade.
 
 Package: yade-doc
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

tmpDirMatplotLib = $(CURDIR)/debian/matplotlib
tmpInstall = $(CURDIR)/debian/inst
CXXFLAGS := -Wall $(shell dpkg-buildflags --get CXXFLAGS)

%:
	dh $@

override_dh_auto_clean:
	rm -rf debian/build
	rm -rf doc/sphinx/_build
	rm -rf tags
	rm -f scons.*
	rm -f *.1
	rm -rf $(tmpDirMatplotLib)
	rm -rf $(tmpInstall)
	find . -name '*.pyc' -print0 | xargs -0 rm -f
	dh_clean 

override_dh_auto_configure:
	mkdir -p $(tmpDirMatplotLib)
	mkdir -p $(tmpInstall)

override_dh_auto_build:
	# remove the profile, if existing, to have clean config
	rm -f scons.*
	#Output an information about available memory and CPU
	-cat /proc/meminfo
	-cat /proc/cpuinfo
	#optimized build
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib)$ ; NO_SCONS_GET_RECENT= scons profile=deb buildPrefix=debian runtimePREFIX=/usr version='' brief=0 chunkSize=2 features=vtk,gts,opengl,qt4,openmp PREFIX=$(tmpInstall) variant='' CXXFLAGS='$(CXXFLAGS)' optimize=1 -j1 march= debug=0 
	# generate manpages
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade --generate-manpage yade.1
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade-batch --generate-manpage yade-batch.1

override_dh_auto_test:
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade --test
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade --check
	#Delete all pyc files
	find . -name '*.pyc' -print0 | xargs -0 rm -f

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_installman:
	dh_installman -p yade yade.1 yade-batch.1

override_dh_compress:
	dh_compress --all -X.py -X.stl -X.gts -X.geo -X.mesh -X.msh -X.pdf -X.png -X.svg -X.txt -X.js -X.inv

binary-indep: 
	dh --until dh_auto_build $@
	#Generate docs
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; cd doc/sphinx; PYTHONPATH=. YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade yadeSphinx.py;
	dh --after dh_auto_build $@
	
binary-arch: 
	dh $@

binary: binary-indep binary-arch
